"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTimer = void 0;
var react_1 = require("react");
var reducer_1 = __importDefault(require("./state/reducer"));
exports.useTimer = function (_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.initialTime, initialTime = _c === void 0 ? 0 : _c, _d = _b.interval, interval = _d === void 0 ? 1000 : _d, _e = _b.step, step = _e === void 0 ? 1 : _e, _f = _b.timerType, timerType = _f === void 0 ? 'INCREMENTAL' : _f, endTime = _b.endTime, onTimeOver = _b.onTimeOver, onTimeUpdate = _b.onTimeUpdate;
    var _g = react_1.useReducer(reducer_1.default, {
        isRunning: false,
        isTimeOver: false,
        time: initialTime,
        timerType: timerType,
    }), state = _g[0], dispatch = _g[1];
    var isRunning = state.isRunning, isTimeOver = state.isTimeOver, time = state.time;
    var advanceTime = react_1.useCallback(function (timeToAdd) {
        dispatch({ type: 'advanceTime', payload: { timeToAdd: timeToAdd } });
    }, []);
    var pause = react_1.useCallback(function () {
        dispatch({ type: 'pause' });
    }, []);
    var reset = react_1.useCallback(function () {
        dispatch({ type: 'reset', payload: { initialTime: initialTime } });
    }, [initialTime]);
    var start = react_1.useCallback(function () {
        if (isTimeOver) {
            reset();
        }
        dispatch({ type: 'start' });
    }, [reset, isTimeOver]);
    react_1.useEffect(function () {
        if (typeof onTimeUpdate === 'function') {
            onTimeUpdate(time);
        }
    }, [time]);
    react_1.useEffect(function () {
        if (isRunning && time === endTime) {
            dispatch({ type: 'stop' });
            if (typeof onTimeOver === 'function') {
                onTimeOver();
            }
        }
    }, [endTime, onTimeOver, time, isRunning]);
    react_1.useEffect(function () {
        var intervalId = null;
        if (isRunning) {
            intervalId = setInterval(function () {
                dispatch({
                    type: 'set',
                    payload: {
                        newTime: timerType === 'DECREMENTAL' ? time - step : time + step,
                    },
                });
            }, interval);
        }
        else if (intervalId) {
            clearInterval(intervalId);
        }
        return function () {
            if (intervalId) {
                clearInterval(intervalId);
            }
        };
    }, [isRunning, step, timerType, interval, time]);
    return { advanceTime: advanceTime, isRunning: isRunning, pause: pause, reset: reset, start: start, time: time };
};
